/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "aggssrt.h"
 /* QuickSort Recursive using while loops */
 /* g6qkrw2 : static, MIDDLE ;med3 possible ; inline InsSort ;  */
 /* g7qkrw2 : static, MIDDLE ;med3 possible ; one InsSort at end*/

char *med3(char *a, char *b, char *c,int(*compare)(const void*,const void*));

void 
x62(void *akeys,int n,int size,int(*compare)(const void*,const void*))
{
  register int M,c,l,r;
  register char *SRC, *DES;
  register char *keys=(char*) akeys, *split;
  register char *pl,*pr,*pm /* , *pt */; 
  static char X[64];

  if (n <= 1) return ;
  l=0; r=n-1; split=X; pl=keys+l*size; pr=keys+r*size;

#if SPLITTER == MIDDLE_KEY
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
/*
if (n>8) {
 pl=keys+l*size; pr=keys+r*size; pm=keys+ ((l+r)>>1)*size;
 pt=med3(pl,pm,pr,compare);
 MEMCPY(split,pt,size);
} else {
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
}
*/
#elif SPLITTER == FIRST_KEY
 MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif






  while (l <= r) {
      while (compare(pl,split)<0) {++l;pl +=size;}
      while (compare(split,pr)<0) {--r;pr -=size;}
      if (l <= r) {
          /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size);
             ++l;--r;pl += size; pr -= size; */
          M=size;
          do  {
             c=*pl; *pl++=*pr;*pr++=c;} while (--M);
          ++l;--r;pr-=size;pr-=size;
       }
  }
  if (r > 0) {
      if ((r+1)< SGQUI ) {
                   pl=keys;
                   for(pr=pl+size;pr< pl+(r+1)*size;pr+=size){
                     MEMCPY(split,pr,size);
                     for(pm=pr;pm>pl && (compare(pm-size,split)>0); pm-=size){
                       MEMCPY((pm),(pm-size),size);
                     }
                     MEMCPY((pm),split,size);
                   }
      }
      else x62 (keys,r+1,size,compare);
  }
  if (l < n) {
      if ((n - l)< SGQUI ) {
                   pl=keys+l*size;
                   for(pr=pl+size;pr< pl+(n-l)*size;pr+=size){
                     MEMCPY(split,pr,size);
                     for(pm=pr;pm>pl && (compare(pm-size,split)>0); pm-=size){
                       MEMCPY((pm),(pm-size),size);
                     }
                     MEMCPY((pm),split,size);
                   }
      }
      else x62 (keys+l*size,n-l,size,compare);
  }
}

void g6qkrw2 (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  x62 (keys,n,size,compare);
}

void 
x72(void *akeys,int n,int size,int(*compare)(const void*,const void*))
{
  register int M,c,l,r; 
  register char *SRC, *DES;
  register char *keys=(char*) akeys, *split;
  register char *pl,*pr /* ,*pm ,*pt */; 
  static char X[64];

  if (n <= 1) return ;
  l=0;  r=n-1;   split=X;   pl=keys+l*size;    pr=keys+r*size;






#if SPLITTER == MIDDLE_KEY
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
/*
if (n>8) {
 pl=keys+l*size; pr=keys+r*size; pm=keys+ ((l+r)>>1)*size;
 pt=med3(pl,pm,pr,compare);
 MEMCPY(split,pt,size);
} else {
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
}
*/
#elif SPLITTER == FIRST_KEY
 MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
 MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif

  while (l <= r) {
      while (compare(pl,split)<0) {++l;pl +=size;}
      while (compare(split,pr)<0) {--r;pr -=size;}
      if (l <= r) {
          /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size);
             ++l;--r;pl += size; pr -= size; */
          M=size;
          do {
               c=*pl; *pl++=*pr;*pr++=c;} while (--M);
          ++l;--r;pr-=size;pr-=size;
       }
   }
  if (r > 0) {
      if ((r+1)< SGQUI ) {
/*
                   pl=keys;
                   for(pr=pl+size;pr< pl+(r+1)*size;pr+=size){
                     MEMCPY(split,pr,size);
                     for(pm=pr;pm > pl && (compare(pm-size,split)>0); pm-=size){
                       MEMCPY((pm),(pm-size),size);
                     }
                     MEMCPY((pm),split,size);
                   }
*/
      }
      else x72 (keys,r+1,size,compare);
  }
  if (l < n) {
      if ((n - l)< SGQUI ) {
/*
                   pl=keys+l*size;
                   for(pr=pl+size;pr< pl+(n-l)*size;pr+=size){
                     MEMCPY(split,pr,size);
                     for(pm=pr;pm > pl &&(compare(pm-size,split)>0); pm-=size){
                       MEMCPY((pm),(pm-size),size);
                     }
                     MEMCPY((pm),split,size);
                   }
*/
      }
      else x72 (keys+l*size,n-l,size,compare);
  }
}


void g7qkrw2 (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  x72  (keys,n,size,compare);
  BGQUI(keys,n,size,compare);
}
