/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "aggssrt.h"
 /* QuickSort Recursive using while ; TAIL recursion  
    insertion sort for-while some optimizations  */
 /* g6qkrw4 : MIDDLE ;med3 possible ; inline InsSort ; tailRe  */

char *
med3(char *a, char *b, char *c,int(*compare)(const void*,const void*))
;



void 
x64(void *akeys,int size,int (*compare) (const void*,const void*),int *L,int *R)
{
  register int M,c,l,r;
  register char *SRC, *DES;
  register char *keys=(char*) akeys, *split;
  register char *pl,*pr,*pm,*pt;
  register int mL,mR;

  if ((*R-*L+1) <= 1) return ; 
  split= (char *) malloc(size*sizeof(char));
  mL=*L;mR=*R;

  while (mL < mR ) {
     l=mL;r=mR;
     pl=keys+l*size ;
     pr=keys+r*size ;
/*
     pm=keys+((l+r)>>1)*size; 
     pm = med3  (pl, pm , pr,compare); MEMCPY(split,pm,size); 
*/
#if SPLITTER == MIDDLE_KEY
/*
    MEMCPY(split,keys+((l+r)>>1)*size,size);
*/
if ((r-l)>8) {
 pl=keys+l*size; pr=keys+r*size; pm=keys+ ((l+r)>>1)*size;
 pt=med3(pl,pm,pr,compare);
 MEMCPY(split,pt,size);
} else {
 MEMCPY(split,keys+((l+r)>>1)*size,size);
}
#elif SPLITTER == FIRST_KEY
    MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
    MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif

     while (l <= r) {
         while (compare(pl,split)<0) {++l;pl +=size;}
         while (compare(split,pr)<0) {--r;pr -=size;}
         if (l <= r) { /* is it ok if < ? */
             /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size);
                ++l;--r;pl += size; pr -= size; */
             M=size;
             do {
                c=*pl; *pl++ = *pr; *pr++=c; } while (--M);
             ++l; pr -=size; --r; pr -=size;
         }
     }
 
  if ((r-mL+1) < (mR-l+1)) { /* Left side smaller */
      if ((r-mL+1) < SGQUI  ) {
                  pl=keys+mL*size;
                  for(pr=pl+size; pr< pl+(r-mL+1)*size; pr +=size){
                    MEMCPY(split,pr,size);
                    for(pm=pr;pm >pl && (compare(pm-size,split)>0); pm-=size) {
                     MEMCPY((pm),(pm-size),size);
                    }
                    MEMCPY((pm),split,size);
                  }
          mL=l;
      }
      else {
         *R=r; *L=mL; /* mL...r */
         x64(keys,size,compare,L,R);
         mL=l;  /* OR r l ..mR */
      }
   } /*left */
  else {               /* Right side smaller */
      if ((mR-l+1) < SGQUI  ) {
               pl=keys+l*size;
               for(pr=pl+size;pr<pl+(mR-l+1)*size;pr+=size){
                    MEMCPY(split,pr,size);
                    for(pm=pr;pm >pl && (compare(pm-size,split)>0); pm-=size) {
                     MEMCPY((pm),(pm-size),size);
                    }
                    MEMCPY((pm),split,size);
               }
       mR=r;
      }
      else {
        *L=l; *R=mR;  /* l...mR */
        x64(keys,size,compare,L,R);
        mR=r;  /* mL ...r */
      }

  } /*right*/
 }
free((void *)split); /* free((void *)tmp); */
}

void g6qkrw4 (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  int myL,myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  myL=0;myR=n-1;
  x64 (keys,size,compare,&myL,&myR);
}

