/**(c) 2020-2021. A. Gerbessiotis. See ../KAagcopy.txt **/
/********************************************************/
#include "aggssrt.h"

void g7qknd0(void *akeys, int n,int size,int(*compare)(const void*,const void*))
{


 register char *keys=(char*) akeys;
 register char *x, *y;
 register int i,j,l,r,s;
 int lstack[STSZ];
 int rstack[STSZ];

 if (n<=1) return;
 x = (char *) malloc(size*sizeof(char));
 y = (char *) malloc(size*sizeof(char));
 s=0;
 lstack[0]=0;rstack[0]=n-1;
 do{
     l=lstack[s]; r=rstack[s]; --s;
     do{
         i=l;
         j=r;
         memcpy(x,&keys[((l+r)/2)*size],size);
         do{
             while (compare(&keys[i*size],x) < 0) ++i;
             while (compare(x,&keys[j*size]) < 0) --j;
             if (i <= j ) {
               memcpy(y,&keys[i*size],size);
               memcpy(&keys[i*size],&keys[j*size],size);
               memcpy(&keys[j*size],y,size);
               ++i; --j;
             }
         } while (i <= j);
         if (i < r) {
           ++s; lstack[s]=i; rstack[s]=r;
         } 
         r=j;
     } while (l<r);
 } while (s>= 0);
 free((void *)y); free((void *)x); 
}
