/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "aggssrt.h"

char *med3(char *a,char *b,char *c,int(*compare)(const void*,const void*));

void g7qknd4(void *akeys,int n,int size,int(*compare)(const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register char *keys=(char*) akeys;
 register char *split,*pi,*pj,*t,*pm;
 register int  i,j,l,r,s,c;
 static   int  lstack[STSZ];
 static   int  rstack[STSZ];

 if (n<=1) return;
 split = (char *) malloc(size*sizeof(char));

 s=0;
 lstack[0]=0;rstack[0]=n-1;
 do{
      l=lstack[s]; r=rstack[s]; --s;
      do{
          i=l;
          j=r;
          pi= keys+i*size; pj= keys+j*size;
          if (n<15) {
            MEMCPY(split,(keys + ((l+r)>>1)*size),size);
          } 
          else {
            t=keys+((i+j)>>1)*size;
            pm = med3(pi,pj,t,compare);
            MEMCPY(split,pm,size);
          }
          do{
              while (compare(pi,split) < 0) {++i;pi+=size;}
              while (compare(split,pj) < 0) {--j;pj-=size;}
              if (i <= j ) {
                M=size;
                do{
                    c= *pi; *pi++ = *pj; *pj++ = c;
                } while (--M);
                ++i; pj -=size; --j; pj -=size;
              }
          } while (i <= j);
          if (i < r) {
            if ((r-i) < SGQUI  )
              BGQUI (pi,(r-i+1),size,compare);
            else {
              ++s; lstack[s]=i; rstack[s]=r;
            }
          }
          r=j;
      } while (l<r);
 } while (s>=0);
 free((void*)split);
}
