/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "aggssrt.h"

void g7qknd6(void *akeys,int n,int size,int(*compare)(const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register char *keys=(char*) akeys;
 register char *split,*pi,*pj;
 register int  i,j,l,r,s,c;
 static   char X[64];
 static   int  lstack[STSZ];
 static   int  rstack[STSZ];

 if (n<=1) return;
 split=X;

 s=0;
 lstack[0]=0;rstack[0]=n-1;
 do{
     l=lstack[s]; r=rstack[s]; --s;
     do{
         i=l;
         j=r;
         pi= keys+i*size; pj= keys+j*size;
         MEMCPY(split,(keys + ((l+r)>>1)*size),size);
         do{
             while (compare(pi,split) < 0) {++i;pi+=size;}
             while (compare(split,pj) < 0) {--j;pj-=size;}
             if (i <= j ) {
               M=size;
               do {
                    c= *pi; *pi++ = *pj; *pj++ = c;
               } while (--M);
               ++i; pj -=size; --j; pj -=size;
             }
         } while (i <= j);
         if (i < r) {
           if ((r-i) < SGQUI  )
             BGQUI (pi,(r-i+1),size,compare);
           else {
             ++s; lstack[s]=i; rstack[s]=r;
           }
         }
         r=j;
     } while ( l < r);
 } while (s>= 0);
}
