/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"
/* Standard quicksort */
void ag51qdrr(void *akeys, int n, int size, int (*compare) (const void*,const void*),int l,int r)
{
 register int M,c,i,j;
 register char *pi,*pj,*SRC,*DES;
 register char *keys=(char*) akeys, *split;


 if (n<=1) return;
 split=(char*) malloc(size*sizeof(char));

 i=l;j=r;
 pi= keys+l*size;
 pj= keys+r*size;

 MEMCPY(split,keys+((l+r)>>1)*size,size);

do
{
    while (compare(pi,split) < 0)  {i++; pi += size;}
    while (compare(split,pj) < 0)  {j--; pj -= size;}
    if (i <= j ) {
       /* MEMCPY(y,pi,size); MEMCPY(pi,pj,size); MEMCPY(pj,y,size);
       i++;j--; pi += size;pj -= size; */
       M=size;
       do  { c=*pi; *pi++=*pj;*pj++=c;} while (--M);
       i++;j--;pj-=size;pj-=size;
    }
}  while (i <= j);
	
	if (l < j) {
		if ((j-l) < THRES16)
			BASES (keys+l*size,(j-l+1),size,compare);
		else
			ag51qdrr(keys,n,size,compare,l,j);
        }
	if (i < r) {
		if ((r-i) < THRES16)
			BASES (keys+i*size,(r-i+1),size,compare);
		else
			ag51qdrr(keys,n,size,compare,i,r);
        }
	
 free((void *)split); 
}

void ag51qd (void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  ag51qdrr(keys,n,size,compare,0,n-1);
}
