/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/
#include "agssrti.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif
 /* (Straight) Insertion Sort */

void d1ins1(data *src,int n)
{   /* j=i-1 */
  register int i,j;
  register data k;

  if (n<=1) return;
  for(i=1;i<n;++i){
     k=src[i];
     j=i-1; 
     while((j>=0)&&(src[j]>k)){
        src[j+1]=src[j];
        --j ; 
     }
     src[j+1]=k;
  }
}

void d1ins2(data *src,int n)
{   /* j=i */
  register int i,j;
  register data k;

  if (n<=1) return;
  for(i=1;i<n;++i){
     k=src[i];
     j=i; 
     while((j> 0)&&(src[j-1]>k)){
        src[j]=src[j-1];
        --j ; 
     }
     src[j]=k;
  }
}

void d1ins3(data *src,int n)
{   /* j=i-1 , p */
  register int i,j,k;
  register data *p;

  if (n <= 1) return;
  for(i=1;i<n;++i) {
     k=src[i];
     j=i-1;  p = src+j;
     while ( (j >= 0 ) && (*p > k )) {
        *(p+1)= *p;
        --j; --p;
     }
     *(p+1)=k;
  }
}

void d1ins4(data *src,int n)
{   /* j=i , p */
  register int i,j,k;
  register data *p;

  if (n <= 1) return;
  for(i=1;i<n;++i) {
     k=src[i];
     j=i;  p = src+(j-1);
     while ( (j >  0 ) && (*p > k )) {
        *(p+1)= *p;
        --j; --p;
     }
     *(p+1)=k;
  }
}

void d1ins5(data *src,int n)
{   /* j=i-1 , p, ip */
  register int     k;
  register data *p,*ip;

  if (n <= 1) return;
  for(ip=src+1;ip<(src+n);++ip) {
     k=*ip;
     p=ip-1;
     while ( (ip >= src ) && (*p > k )) {
        *(p+1)= *p;
         --p;
     }
     *(p+1)=k;
  }
}

void d1ins7(data *src,int n)
{   /* j=i-1 , p, ip, for */
  register int     k;
  register data *p,*ip;

  if (n <= 1) return;
  for(ip=src+1;ip<(src+n);++ip) {
     k=*ip;
     for( p = ip ; (ip > src) && (*(p-1) > k) ; --p){
        *p= *(p-1);
     }
     *p=k;
  }
}

void d1ins8(data *src,int n)
{   /* j=i-1 , p, ip, for */
  register data *p,*ip;

  if (n <= 1) return;
  for(ip=src+1;ip<(src+n);++ip) {
     for( p = ip ; (ip > src) && (*(p-1) > *ip) ; --p){
        *(p)= *(p-1);
     }
     *(p+1)=*ip;
  }
}

