/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/
#include "agssrti.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif
 /* HeapSort */

void i5auxx1(int  *keys,int n,int l,int r)
{
  register int i,j;
  register int   x;

  i=l;j=2*i;
  x=keys[i-1];

  while (j <= r) {
    if (j < r) {
      if (keys[j-1]< keys[j]) {
        ++j;
       }
    }
    if (x>=keys[j-1])
      break;

     keys[i-1]=keys[j-1];
     i=j;j=2*i;
   }
   keys[i-1]=x;
}


void i5heapx1(int  *keys, int n)
{
  register int l,r;
  register int   x;

  l = n/2+1; r=n;

  while (l > 1) {
    l--;
    i5auxx1(keys,n,l,r);
  }
  while (r > 1) {
    x=keys[0];
    keys[0]=keys[r-1];
    keys[r-1]=x;
    r--;
    i5auxx1(keys,n,l,r);
  }

}




/****   Copyright (c) 1997-2019  Constantionos J. Siniolakis and
 ****                            Alexandros V. Gerbessiotis
 ****
 ****   Permission to use, copy, modify, and distribute this software,
 ****   and to incorporate it, in whole or in part, into other software,
 ****   is hereby granted without fee, provided that
 ****     (1) the above copyright notice and this permission notice appear in
 ****         all copies of the source code, and the above copyright notice
 ****         appear in clearly visible form on all supporting documentation
 ****         and distribution media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects; use this code on your own personal risk
 ****/

#define L(i) ((i<<1)+1)
#define R(i) ((i<<1)+2)
#define P(i) ((i-1)>>1)

void Heapifyd(int  *heap,int n,int i)
{
  register int  l, r,t,tmp;

  l= L(i) ; r= R(i) ;

  if ((l < n) && (heap[l]>heap[i]))
       t= l ;
  else t= i ;
  if ((r < n) && (heap[r]>heap[t]))
       t= r ;

  if (t != i)
    {
      tmp=heap[i];
      heap[i]=heap[t];
      heap[t]=tmp;
      Heapifyd(heap, n, t);
    }
}

void Build_Heapi(int   *heap, int n)
{
  register int  i;

  for (i=n-1 ;i >= 0; --i)
    {
      Heapifyd(heap,n,i);
    }
}

void i5heapx3(int  *keys, int n)
{
 register int  tmp;
 register int i;

 Build_Heapi(keys,n);
 for (i = n-1;i>=1;--i){
  tmp=keys[0];
  keys[0]=keys[i];
  keys[i]=tmp;
  Heapifyd(keys,i,0);
  }
}

