/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/


#include <memory.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

typedef int    data;

#ifndef MIN
#define	MIN(x,y)	((x)<=(y)?(x):(y)) 
#endif

#define GRANDOM(X)  (int)((random()/((double)2147483647.0))*X)
#define GSRANDOM()   srandom((unsigned int)time(NULL))

#define SWAPP(i1,i2) \
  {ii = size;do {k = *(i1);*(i1)++ = *(i2);*(i2)++ = k;} while(--ii);}
#define SWAPPY(XX,YY,TT,SS) {DES=(XX);SRC=(YY);M=(SS); do {*TT=*DES;*DES++=*SRC;*SRC++=*TT;} while ( --M); }

/*
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#undef MEMCPY
*/
#define MEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }
#define IMEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }

void g8mf2   (void *, void *, int, int, int, int (*)(const void*,const void*));
void g8mf3   (void *, void *, int, int, int, int (*)(const void*,const void*));
void g8mf3o  (void *, void *, int, int, int, int (*)(const void*,const void*));
void g8mf3x  (void *, void *, int, int, int, int (*)(const void*,const void*));
void g8mf4   (void *, void *, int, int, int, int (*)(const void*,const void*));
void g8mf4o  (void *, void *, int, int, int, int (*)(const void*,const void*));

void g8mw2   (void *, void *, int, int, int, int (*)(const void*,const void*));
void g8mw3o  (void *, void *, int, int, int, int (*)(const void*,const void*));
void g8mw4   (void *, void *, int, int, int, int (*)(const void*,const void*));


