/****(c) 2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/


#include <memory.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "agidata.h"

#ifndef MIN
#define MIN(x,y)  ((x)<=(y)?(x):(y))
#endif

#define GRANDOM(X)  (int)((random()/((double)2147483647.0))*X)
#define GSRANDOM()   srandom((unsigned int)time(NULL))

/* 2021 code definitions start here */
        /* BG:BaselinGenericSorting in MRG: MergeSort; D:Data I:Int */
#define BGMRG    g1ins7
#define BDMRG    d1ins5
#define BIMRG    i1ins5
        /* Cutoff size for InsertionSort */
#define SGMRG    16
#define SDMRG    24
#define SIMRG    24
        /* BG:BaselinGenericSorting in QUI: QuickSort */
#define BGQUI    g1ins7
#define BDQUI    d1ins5
#define BIQUI    i1ins5
        /* Cutoff size for InsertionSort */
#define SGQUI    16
#define SDQUI    32
#define SIQUI    32

#define STSZ       64
#define FIRST_KEY  0
#define MIDDLE_KEY 1
#define RANDOM_KEY 2
#define SPLITTER  MIDDLE_KEY
/* 2021 code definitions end   here */

#define SWAPP(i1,i2) \
  {ii = size;do {k = *(i1);*(i1)++ = *(i2);*(i2)++ = k;} while(--ii);}
#define SWAPPY(XX,YY,TT,SS) {DES=(XX);SRC=(YY);M=(SS); do {*TT=*DES;*DES++=*SRC;*SRC++=*TT;} while ( --M); }

#define MEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }
#define IMEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }


void i0gnu   (void *,int ,int ,int (*)(const void*,const void*));


void i1ins1  (idata   * , int );
void i1ins2  (idata   * , int );
void i1ins3  (idata   * , int );
void i1ins4  (idata   * , int );
void i1ins5  (idata   * , int );
void i4mrgi1 (idata   * , int );
void i5hpx1  (idata   * , int );
void i5hpx3  (idata   * , int );
void i6qkrd1 (idata   * , int );
void i6qkrf1 (idata   * , int );  /* i6clrs renamed */
void i6qkrw1 (idata   * , int );
void i6clrs  (idata   * , int );
void i7qknd1 (idata   * , int );  /* previously name i7qknd0 */
void i7qknd2 (idata   * , int );

void i9rdx4u (idata   * , int );
void i9rdx4o (idata   * , int );

/* ALTERNATIVES FOR INLINE MEMCPY ...*/
/*
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#undef MEMCPY
SWAP(char *x, char *y, int    size)
{
  while(size-- > 0) {
    char tmp = *x;
    *x++ = *y;
    *y++ = tmp;
  }
}
MEMCPY(void *x, void *y, int    size)
{
  while(size-- > 0) {
    char *pbTo = (char *)x;
    char *pbFrom = (char *)y;
    *pbTo++ = *pbFrom++;
  }
}
*/
