/****(c) 2020-2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/************************************************************/
#include "agissrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif
 /* (Straight) Insertion Sort */

void i1ins1(idata *src,int n)
{   /* j=i-1 */
  register int i,j;
  register idata k;

  if (n<=1) return;
  for(i=1;i<n;++i){
     k=src[i];
     j=i-1; 
     while((j>=0)&&(src[j]>k)){
        src[j+1]=src[j];
        --j ; 
     }
     src[j+1]=k;
  }
}

void i1ins2(idata *src,int n)
{   /* j=i */
  register int i,j;
  register idata k;

  if (n<=1) return;
  for(i=1;i<n;++i){
     k=src[i];
     j=i; 
     while((j> 0)&&(src[j-1]>k)){
        src[j]=src[j-1];
        --j ; 
     }
     src[j]=k;
  }
}

void i1ins3(idata *src,int n)
{   /* j=i-1 , p */
  register int i,j;
  register idata k, *p;

  if (n <= 1) return;
  for(i=1;i<n;++i) {
     k=src[i];
     j=i-1;  p = src+j;
     while ( (j >= 0 ) && (*p > k )) {
        *(p+1)= *p;
        --j; --p;
     }
     *(p+1)=k;
  }
}

void i1ins4(idata *src,int n)
{   /* j=i , p */
  register int i,j;
  register idata *p,k;

  if (n <= 1) return;
  for(i=1;i<n;++i) {
     k=src[i];
     j=i;  p = src+(j-1);
     while ( (j >  0 ) && (*p > k )) {
        *(p+1)= *p;
        --j; --p;
     }
     *(p+1)=k;
  }
}

void i1ins5(idata *src,int n)
{   /* j=i-1 , p, ip */
  register idata *p,*ip,k;

  if (n <= 1) return;
  for(ip=src+1;ip<(src+n);++ip) {
     k=*ip;
     p=ip-1;
     while ( (p >= src ) && (*p > k )) {
        *(p+1)= *p;
         --p;
     }
     *(p+1)=k;
  }
}

void i1ins7(idata *src,int n)
{   /* j=i-1 , p, ip, for */
  register idata k,*p,*ip;

  if (n <= 1) return;
  for(ip=src+1;ip<(src+n);++ip) {
     k=*ip;
     for( p = ip ; (p > src) && (*(p-1) > k) ; --p){
        *p= *(p-1);
     }
     *p=k;
  }
}
