/****(c) 2020-2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/************************************************************/
#include "agissrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

 /* Integer QuickSort Recursive using while   */

void i6qkrw1a (idata *akeys, unsigned int n)
{
 register unsigned int i, j;
 register idata split,tmp;
 register idata *keys=(idata*) akeys;

 if (n <=1) return;
 i=0;j=n-1;

#if   SPLITTER == MIDDLE_KEY
 split=keys[n/2];
#elif SPLITTER == FIRST_KEY
 split=keys[0];
#elif SPLITTER == RANDOM_KEY
 split=keys[GRANDOM(n)];
#endif
 /*  split=keys[0]; */ /* split = keys[GRANDOM(n)] */
  while (i <= j) {
      while (keys[i]<split) ++i;
      while (keys[j]>split) --j;
      if (i <= j) {
          tmp=*(keys+i);
          *(keys+i)=*(keys+j);
          *(keys+j)=tmp;
/*
          tmp=keys[i];
          keys[i]=keys[j];
          keys[j]=tmp;
*/
          ++i; --j;
      }
   }
  if (j > 0) {
      if ((j + 1) <   SIQUI )  BIQUI(keys, j + 1);
      else i6qkrw1a(keys, j + 1);
  }
  if (i < n) {
      if ((n - i) <   SIQUI)  BIQUI(keys+i, n - i);
      else i6qkrw1a(keys+i, n - i);
  }
}

void i6qkrw1(idata *keys, int n)
{
 if (n<=1) return;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  i6qkrw1a(keys,(unsigned int)n);
}

void i6clrs0a(idata *keys, int n, unsigned int l, unsigned int r)
{
  register unsigned int i,j;
  register idata pr,pm,tmp;

  if (n <= 1) return ;
  pr=*(keys+r);
#if SPLITTER == MIDDLE_KEY
  pm = keys[(l+r)>>1];
#elif SPLITTER == FIRST_KEY
  pm = keys[l];
#elif SPLITTER == RANDOM_KEY
  pm = keys[(l+GRANDOM((r-l+1)))];
#endif
  tmp=pm; pm=pr; pr=tmp;
  i=l-1; j=l;

  for(j=l;j<r;++j) {
    if (keys[j]<=keys[r]) {
       ++i;
       tmp=*(keys+j);
       *(keys+j)=*(keys+i);
       *(keys+i)=tmp;
    }
  }
  ++i;
  tmp=*(keys+r);
  *(keys+r)=*(keys+i);
  *(keys+i)=tmp;

  if ((i-l) <   SIQUI  )
      BIQUI(keys+l,(i-l));
  else
     i6clrs0a(keys+l,i-l,0,i-l-1);
  if ((r-i) <   SIQUI )
      BIQUI(keys+(i+1),(r-i));
   else
     i6clrs0a(keys+(i+1),r-i,0,r-i-1);

}

void i6clrs(idata *keys, int n)
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  i6clrs0a(keys,n,(unsigned int) 0,(unsigned int) (n-1));
}

void i6qkrf1(idata *keys, int n)
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  i6clrs0a(keys,n,(unsigned int) 0,(unsigned int) (n-1));
}
