/****(c) 2020-2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/************************************************************/
#include "agissrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

 /* Integer QuickSort Non-Recursive using do  ; very simple version */
void i7qknd1(idata *keys, int n)
{
  register int i,j,l,r,s;
  register idata   x,y;
  int   lstack[STSZ];
  int   rstack[STSZ];
  if (n<=1) return;
  s=0;
  lstack[0]=0;rstack[0]=n-1;
  do {
    l=lstack[s]; r=rstack[s]; --s;
    do {
      i=l;
      j=r;
      x=keys[(l+r)/2];
      do {
        while (keys[i] < x) ++i;
        while (x<keys[j] ) --j;
        if (i <= j ) {
          y=keys[i];
          keys[i]=keys[j];
          keys[j]=y;
          ++i; --j;
        }
       } while (i <= j);
       if (i < r) {
         ++s; lstack[s]=i; rstack[s]=r;
       }
       r=j;
    } while ( l < r);
  } while (s>= 0);
}

 /* Integer QuickSort Non-Recursive using do;memhp x,y; 2nd simplest version */

void i7qknd2 (idata *keys, int n)
{
 register int   i,j,l,r,s;
 register idata split,tmp;
 int   lstack[STSZ];
 int   rstack[STSZ];

  s=0;
  lstack[0]=0;rstack[0]=n-1;
do {
    l=lstack[s]; r=rstack[s]; --s;
    do {
        i=l;
        j=r;
        split=keys[(l+r)/2];

        do {
           while (keys[i] < split) ++i;
           while (keys[j] > split)   --j;
            if (i <= j ) {
              tmp=*(keys+i);
              *(keys+i)=*(keys+j);
              *(keys+j)=tmp;
/*
              tmp=keys[i];
              keys[i]=keys[j];
              keys[j]=tmp;
*/
              ++i; --j;
             }
        } while (i <= j);
        if (i < r) {
          if ((r-i)<SIQUI   ) {
             BIQUI(&keys[i],(r-i+1));
          }
          else {
            ++s; lstack[s]=i; rstack[s]=r;
           }
        }
        r=j;
      } while ( l < r);

} while (s>= 0);
}
