/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agdssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

 /* Data QuickSort Recursive using do   */
void 
d6qkrd1a(ddata *akeys, unsigned int n, unsigned int l, unsigned int r)
{
  register unsigned int i,j;
  register ddata split,tmp, *keys=akeys;

  i=l;j=r;
#if   SPLITTER == MIDDLE_KEY
  split=keys[(l+r)/2];
#elif SPLITTER == FIRST_KEY
  split=keys[l];
#elif SPLITTER == RANDOM_KEY
  split=keys[l+GRANDOM((r-l+1))];
#endif
  do {
        while (keys[i]<split) ++i;
        while (split<keys[j]) --j;
        if (i <= j ) {
          tmp=*(keys+i);
          *(keys+i)=*(keys+j);
          *(keys+j)=tmp;
          ++i;--j;
        }
  } while (i <= j);

  if (l < j) {
    if ((j-l) < SDQUI  )
       BDQUI(keys+l,(j-l+1));
    else
       d6qkrd1a(keys,n,l,j);
  }
  if (i < r) {
    if ((r-i) < SDQUI  )
       BDQUI(keys+i,(r-i+1));
    else
      d6qkrd1a(keys,n,i,r);
  }
}

void d6qkrd1(ddata *keys, int n)
{
 if (n<=1) return;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
 d6qkrd1a(keys,(unsigned int) n,(unsigned int) 0, (unsigned int)( n-1));
}

ddata *i3(ddata*, ddata*, ddata*);

void 
d6qkrd2a(ddata *akeys, unsigned int n, unsigned int l, unsigned int r)
{
  register unsigned int i,j;
  register ddata split,tmp, *keys=akeys, *Z;

  i=l;j=r;
#if   SPLITTER == MIDDLE_KEY
  split=keys[(l+r)/2];
  if (n>8){
    Z=i3(keys+l,keys+r,keys+((l+r)>>1));
    split= *Z;
  }
#elif SPLITTER == FIRST_KEY
  split=keys[l];
#elif SPLITTER == RANDOM_KEY
  split=keys[l+GRANDOM((r-l+1))];
#endif
  do {
        while (keys[i]<split) ++i;
        while (split<keys[j]) --j;
        if (i <= j ) {
          tmp=*(keys+i);
          *(keys+i)=*(keys+j);
          *(keys+j)=tmp;
          ++i;--j;
        }
  } while (i <= j);

  if (l < j) {
    if ((j-l) < SDQUI  )
       BDQUI(keys+l,(j-l+1));
    else
       d6qkrd2a(keys,n,l,j);
  }
  if (i < r) {
    if ((r-i) < SDQUI  )
       BDQUI(keys+i,(r-i+1));
    else
      d6qkrd2a(keys,n,i,r);
  }
}

void d6qkrd2(ddata *keys, int n)
{
 if (n<=1) return;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
 d6qkrd2a(keys,(unsigned int) n,(unsigned int) 0, (unsigned int)( n-1));
}
