/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"

void avg43hxs (void *akeys,int n,int size,int (*compare)(const void*,const void*),int l,int r)
{
  register int i,j,M;
  register char	*tmp,*keys=(char*) akeys,*SRC,*DES;

  if (n<=1) return;
  if (size<1) return;
  tmp=(char *)malloc(size*sizeof(char));
  i=l;j=2*i;
  MEMCPY(tmp,&keys[(i-1)*size],size);

  while(j<=r){
    if (j<r){
      if (compare(&keys[(j-1)*size],&keys[(j)*size])<=0) {
	j++;
       }
    }
    if (compare(tmp,&keys[(j-1)*size])>0) break;

     MEMCPY(&keys[(i-1)*size],&keys[(j-1)*size],size);
     i=j;j=2*i;
   }
   MEMCPY(&keys[(i-1)*size],tmp,size);
   free((void*)tmp);
}
	

void avg43hx(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
  register int l,r,M;
  register char *tmp,*keys=(char*) akeys,*SRC,*DES;

  l=n/2+1;r=n;
  tmp=(char *)malloc(size*sizeof(char));

  while(l>1) {
    l--;
    avg43hxs(keys,n,size,compare,l,r);
  }
  while (r > 1) {
    MEMCPY(tmp,keys,size);
    MEMCPY(keys,&keys[(r-1)*size],size);
    MEMCPY(&keys[(r-1)*size],tmp,size);
    r--;
    avg43hxs(keys,n,size,compare,l,r);
  }
  free((void*)tmp);
}
