/****Copyright (c) 1997-2005 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/

#include "issrt.h"

void i45hxs(idata *keys,int n,int l,int r)
{
  register int i,j;
  register idata x;

  i=l;j=2*i;
  x=keys[i-1];

  while (j <= r) {
    if (j < r) {
      if (keys[j-1]< keys[j]) {
	j++;
       }
    }
    if (x>=keys[j-1])
      break;

     keys[i-1]=keys[j-1];
     i=j;j=2*i;
   }
   keys[i-1]=x;
}
	

void i45hx(idata *keys, int n)
{
  register int l,r;
  register idata x;

  l = n/2+1; r=n;

  while (l > 1) {
    l--;
    i45hxs(keys,n,l,r);
  }
  while (r > 1) {
    x=keys[0];
    keys[0]=keys[r-1];
    keys[r-1]=x;
    r--;
    i45hxs(keys,n,l,r);
  }

}
