/****Copyright (c) 1997-2005 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "issrt.h"
 /* CLRS version */

void i63fbcm(idata *keys, int   n,int l,int r)
{
  register int  i,j;
  register idata pl,pr,pm,tmp;

  if (n <= 1) return ;
  pl=keys[l];
  pr=keys[r];
#if SPLITTER == MIDDLE_KEY
  pm = keys[((l+r)/2 )];
#elif SPLITTER == FIRST_KEY
  pm = keys[l];
#elif SPLITTER == RANDOM_KEY
  pm = keys[(l+GRANDOM((r-l+1)))];
#endif
  tmp=pm;
  pm=pr;
  pr=tmp;
  i=l-1; 
  j=l  ; 
  for(j=l;j<r;j++) {
    if (keys[j]<=keys[r]) {
       i++;
       tmp=keys[j];
       keys[j]=keys[i];
       keys[i]=tmp;
    }
  }
  i++;
  tmp=keys[r];
  keys[r]=keys[i];
  keys[i]=tmp;

  if ((i-l) < THRESI16)
     BASEI(&keys[l],(i-l));
  else
     i63fbcm(&keys[l],i-l,0,i-l-1);
  if ((r-i) < THRESI16)
     BASEI(&keys[(i+1)],(r-i));
   else
     i63fbcm(&keys[(i+1)],r-i,0,r-i-1);

}
           
void i63fbc(idata *keys, int n)
{
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  i63fbcm(keys,n,0,n-1);
}

