/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "aggssrt.h"
 /* QuickSort Recursive using while loops */
 /* rudimentary tail recursion */
 /* g6qkrw1 : MIDDLE ;med3 possible ; inline InsSort ;  */
 /* g7qkrw1 : MIDDLE ;med3 possible ; one InsSort at end*/

char *
med3(char *a, char *b, char *c,int(*compare)(const void*,const void*))
;


void 
x61(void *akeys,int size,int (*compare)(const void*,const void*),int mL,int mR)
{
  register int  M,c,l,r;
  register char *SRC, *DES;
  register char *keys=(char *) akeys, *split;
  register char *pl,*pr,*pm, *pt;
  static char X[64];


  if ((mR-mL) <= 0) return ; /* if ((mR-mL+1) <= 1) return ; */
  split = X;

  while (mL < mR ) { 
     l=mL;r=mR;
     pl=keys+l*size; 
     pr=keys+r*size;




#if SPLITTER == MIDDLE_KEY
/*
    MEMCPY(split,keys+((l+r)>>1)*size,size);
*/
if ((r-l)>8) {
 pl=keys+l*size; pr=keys+r*size; pm=keys+ ((l+r)>>1)*size;
 pt=med3(pl,pm,pr,compare);
 MEMCPY(split,pt,size);
} else {
 MEMCPY(split,keys+((l+r)>>1)*size,size);
}
#elif SPLITTER == FIRST_KEY
    MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
    MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif

     while (l <= r) {
         while (compare(pl,split)< 0) {++l; pl +=size;}
         while (compare(split,pr)< 0) {--r; pr -=size;}
         if (l <= r) { /* is it ok if < ? */
             /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size);
    	        ++l;--r;pl += size; pr -= size; */
             M=size;
             do {
                c=*pl; *pl++ = *pr; *pr++=c; } while (--M);
             ++l; pr -=size; --r; pr -=size;
         }
     }
  
   if ((r-mL) < (mR-l)) {/* Left side smaller;eliminated a +1 from both sides */
      if ((r-mL+1) < SGQUI  ) {/* usedto be r-mL+1 > 1 */
                 if ((r-mL) >0) {   
                  pl=keys+mL*size;
                  for(pr=pl+size; pr< pl+(r-mL+1)*size; pr +=size){
                    MEMCPY(split,pr,size);
                    for(pm=pr;pm>pl && (compare(pm-size,split)>0); pm-=size) {
                     MEMCPY((pm),(pm-size),size);
                    }
                    MEMCPY((pm),split,size);
                  }
                 }
          mL=l;
      }
      else {
         x61(keys,size,compare,mL,r);
         mL=l;  /* OR r l ..mR */
      }
   } /*left */
  else {               /* Right side smaller */
      if ((mR-l) < SGQUI  ) { /* used to be mR-l+1 >1 */
               if ((mR-l) >0) { 
               pl=keys+l*size;
               for(pr=pl+size;pr<pl+(mR-l+1)*size;pr+=size){
                    MEMCPY(split,pr,size);
                    for(pm=pr;pm>pl && (compare(pm-size,split)>0); pm-=size) {
                     MEMCPY((pm),(pm-size),size);
                    }
                    MEMCPY((pm),split,size);
               }
              }
       mR=r;
      }
      else {
        x61(keys,size,compare,l,mR);
        mR=r;  /* mL ...r */
      }
  } /*right*/
 }
}
           

void g6qkrw1(void *keys,int n,int size,int(*compare)(const void*,const void *))
{
  int myL,myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  myL=0;myR=n-1;
   x61(keys,size,compare,myL,myR);
}


/*****************************************************************/


void 
x71(void *akeys,int size,int(*compare)(const void*,const void*),int mL,int mR)
{
  register int  M,c,l,r;
  register char *SRC,*DES;
  register char *keys=(char *) akeys, *split;
  register char *pl,*pr, *pm, *pt;
  static char X[64];


  if ((mR-mL) <= 0) return ; /* if ((mR-mL+1) <= 1) return ; */
  split = X;

  while (mL < mR ) { 
     l=mL;r=mR;
     pl=keys+l*size; 
     pr=keys+r*size;
#if SPLITTER == MIDDLE_KEY
/*
    MEMCPY(split,keys+((l+r)>>1)*size,size);
*/
if ((r-l)>8) {
 pl=keys+l*size; pr=keys+r*size; pm=keys+ ((l+r)>>1)*size;
 pt=med3(pl,pm,pr,compare);
 MEMCPY(split,pt,size);
} else {
 MEMCPY(split,&keys[((l+r)>>1)*size],size);
}
#elif SPLITTER == FIRST_KEY
    MEMCPY(split,&keys[l*size],size);
#elif SPLITTER == RANDOM_KEY
    MEMCPY(split,&keys[(l+GRANDOM((r-l+1)))*size],size);
#endif

     while (l <= r) {
         while (compare(pl,split)< 0) {++l; pl +=size;}
         while (compare(split,pr)< 0) {--r; pr -=size;}
         if (l <= r) { /* is it ok if < ? */
             /* MEMCPY(tmp,pl,size); MEMCPY(pl,pr,size); MEMCPY(pr,tmp,size);
    	        ++l;--r;pl += size; pr -= size; */
             M=size;
             do {
                 c=*pl; *pl++ = *pr; *pr++=c; } while (--M);
               ++l; pr -=size; --r; pr -=size;
         }
     }
  
   if ((r-mL) < (mR-l)) {/* Left side smaller;eliminated a +1 from both sides */
      if ((r-mL+1) < SGQUI  ) {/* usedto be r-mL+1 > 1 */
/*
                 if ((r-mL) >0) {   
                  pl=keys+mL*size;
                  for(pr=pl+size; pr< pl+(r-mL+1)*size; pr +=size){
                    MEMCPY(split,pr,size);
                    for(pm=pr;pm > pl && (compare(pm-size,split)>0); pm-=size) {
                     MEMCPY((pm),(pm-size),size);
                    }
                    MEMCPY((pm),split,size);
                  }
                 }
*/
          mL=l;
      }
      else {
        x71(keys,size,compare,mL,r);
        mL=l;  /* OR r l ..mR */
      }
   } /*left */
  else {               /* Right side smaller */
      if ((mR-l) < SGQUI  ) { /* used to be mR-l+1 >1 */
/*
               if ((mR-l) >0) { 
               pl=keys+l*size;
               for(pr=pl+size;pr<pl+(mR-l+1)*size;pr+=size){
                    MEMCPY(split,pr,size);
                    for(pm=pr;pm > pl && (compare(pm-size,split)>0); pm-=size) {
                     MEMCPY((pm),(pm-size),size);
                    }
                    MEMCPY((pm),split,size);
               }
              }
*/
        mR=r;
      }
      else {
        x71(keys,size,compare,l,mR);
        mR=r;  /* mL ...r */
      }
      
  } /*right*/
 }
}



void g7qkrw1(void *keys,int n,int size,int(*compare)(const void*,const void *))
{
  int myL,myR;
  if (n <= 1) return ;
#if SPLITTER == RANDOM_KEY
 GSRANDOM();
#endif
  myL=0;myR=n-1;
  x71(keys,size,compare,myL,myR);
  BGQUI(keys,n,size,compare);
}
