/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"
   /* used to be oavg30mi.c now has become avg30mii.c last i for inline inssort */
void ag30mii (void *akeys,int n,int size,int (*compare)(const void*,const void*) )
{
  register char *keys= (char *) akeys;
  register char *DES,*SRC;
  register int M;
  register char *temp,*tmp, *s, *t;
  register int  i,j,k,ii,jj,a,b;

  if (n<=1) return;
  temp=(char *)malloc(n*size*sizeof(char));

  a=n/TMERGE;b=TMERGE*size;
  for(j=0;j<a;j++,keys+=b) {
      /* BASES (keys,TMERGE,size,compare); */
      tmp=keys;
      for(s=tmp+size;s<tmp+b          ;s+=size){
        MEMCPY(temp,s,size);
        for(t=s;t > tmp &&(compare(t-size,temp)>0);t-=size){
          MEMCPY((t),(t-size),size);
        }
        MEMCPY((t),temp,size);
      }
  }
  if (a*TMERGE < n) {
      /* BASES (keys,n-a*TMERGE,size,compare); */
      tmp=keys;
      for(s=tmp+size;s<tmp+(n-a*TMERGE)*size;s+=size){
        MEMCPY(temp,s,size);
        for(t=s;t > tmp &&(compare(t-size,temp)>0);t-=size){
          MEMCPY((t),(t-size),size);
        }
        MEMCPY((t),temp,size);
      }
  }

  keys=(char *) akeys; /* recover original keys */

  s=keys;t=temp;
  for(a=TMERGE;a<n;a=(a+a)) { 
     for(b=0;b<n;b+=(a+a)) {
         ii=MIN((b+(a+a)),n)*size;jj=MIN((b+a),n)*size; 
         i=jj;j=b*size;k=b*size; 
         while ((i<ii)&&(j<jj)) {
           if (compare(s+i,s+j)<0) {
              MEMCPY((t+k),(s+i),size);
              i+=size; k+=size;
           }
           else {
              MEMCPY((t+k),(s+j),size);
              j+=size;k+=size;
           }
         }
         if (i<ii) MEMCPY((t+k),(s+i),(ii-i));    
         if (j<jj) MEMCPY((t+k),(s+j),(jj-j));
     }
     tmp=s;s=t;t=tmp;
  }

  if (s!=keys) MEMCPY(keys,s,n*size); 

  free((void *)temp);
}
