/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"

void ag45hxs(void *akeys,int n,int size,int (*compare)(const void*,const void*),int l,int r)
{
  register int i,j,M;
  register char	*tmp,*keys=(char*) akeys,*SRC,*DES;

  if (n<=1) return;
  tmp=(char *)malloc(size*sizeof(char));
  i=l;j=i+i;
  MEMCPY(tmp,keys+(i-1)*size,size);

  while(j<=r){
    if (j<r){
      if (compare(keys+(j-1)*size,keys+j*size)<0) {
	j++;
       }
    }
    if (compare(tmp,keys+(j-1)*size)>=0) break;

     MEMCPY(keys+(i-1)*size,keys+(j-1)*size,size);
     i=j;j=i+i;
   }
   MEMCPY(keys+(i-1)*size,tmp,size);
   free((void*)tmp);
}
	

void ag45hx (void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
  register int l,r,c,M;
  register char *tmp,*keys=(char*) akeys,*SRC,*DES;

  l=(n>>1)+1;r=n;
  tmp=(char *)malloc(size*sizeof(char));

  while(l>1) {
    l--;
    ag45hxs(keys,n,size,compare,l,r);
  }
  while (r > 1) {
    M=size; SRC=keys; DES=keys+(r-1)*size;
    do { c=*SRC; *SRC++=*DES; *DES++=c;} while (--M);
    r--;
    ag45hxs(keys,n,size,compare,l,r);
  }
  free((void*)tmp);
}
