/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"
/* Standard quicksort */
void ag51qrro (void *akeys, int n, int size, int (*compare) (const void*,const void*),int *L,int *R)
{
 register int M,c,i,j,l,r;
 register char *keys=(char*) akeys;
 register char *pi,*pj,*pp,*SRC,*DES, *split;
 static char X[64];

 if (n<=1) return;
 split=X;

 l=*L;r=*R;
while (l < r) {
 i=l;j=r;
 pi= keys+l*size;
 pj= keys+r*size;

 MEMCPY(split,&keys[((l+r)>>1)*size],size);

do
{
   while (compare(pi,split) < 0)  {i++; pi += size;}
   while (compare(split,pj) < 0)  {j--; pj -= size;}
   if (i <= j ) {
      M=size;
      do  { c=*pi; *pi++=*pj;*pj++=c;} while (--M);
      i++;j--;pj-=size;pj-=size;
   }
} while (i <= j);

     if ((j-l)<(r-i)) {
       *L=l; *R=j;
       if (l<j) {
         if ((j-l) < THRES16) {
                   pi=keys+l*size;
                   for(pj=pi+size;pj< pi+(j-l+1)*size;pj+=size){
		     MEMCPY(split,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,split)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),split,size);
                   }
         }
         else
			ag51qrro (keys,n,size,compare,L,R);
       } 
       l=i; 
     }
     else  {
       *L=i; *R=r;
       if (i<r) {
         if((r-i) < THRES16) {
                  pi=keys+i*size;
                   for(pj=pi+size;pj< pi+(r-i+1)*size;pj+=size){
		     MEMCPY(split,pj,size);
                     for(pp=pj;pp > pi &&(compare(pp-size,split)>0); pp-=size){
                       MEMCPY((pp),(pp-size),size);
                     }
                     MEMCPY((pp),split,size);
                   }
         }
         else
			ag51qrro (keys,n,size,compare,L,R);
       }
       r=j;
     }
 
}
}

void ag51qro(void *keys, int n, int size, int (*compare) (const void*,const void *))
{
  int L,R;
  if (n<=1) return;
  L=0;R=n-1;
  ag51qrro (keys,n,size,compare,&L,&R);
}
