/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/

#include "agssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif
 /* Bubble Sort */


void q2bub1(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register int i,j;
 register char	*t, *keys;

 if (n <= 1) return;
 keys = (char *) akeys;
 t    = (char *) malloc(size*sizeof(char));

 for(i=1;i<n;++i) {
   MEMCPY(t,keys+i*size,size);
   for(j=n-1;j>=i;--j) {
     if (compare( keys+(j-1)*size , keys+j*size ) > 0) {
       MEMCPY(t, keys+(j-1)*size ,size);
       MEMCPY( keys+(j-1)*size , keys+j*size ,size);
       MEMCPY( keys+j*size ,t,size);
     }
   }
 }
 free((void*)t);
}

