/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/

#include "agssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif

/* Selection Sort */

void q2sel1(void *akeys, int n, int size, int (*compare)(const void*,const void*))
{   /* i,j,k  no p */
 register int M;
 register char *SRC, *DES;
 register int i, j, m;
 register char	*k, *keys;

 if (n<=1) return;
 keys = (char *) akeys;
 k    = (char *) malloc(size*sizeof(char));

 for(i=0;i<n-1;++i) {
   m=i;
   MEMCPY(k,keys+i*size,size);
   for(j=i+1;j<n;++j) {
     if (compare(keys+j*size,k) < 0) {
       m=j;
       MEMCPY(k,keys+j*size,size);
     }
   }
   MEMCPY(keys+m*size,keys+i*size,size);
   MEMCPY(keys+i*size,k,size);
 }
 free((void*)k);
}

void q2sel2(void *akeys, int n, int size, int (*compare)(const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register int i,j,m;
 register char	*k, *keys,*p;

 if (n <= 1) return;
 keys = (char *) akeys;
 k    = (char *) malloc(size*sizeof(char));

 for(i=0;i<n-1;++i) {
   m=i; 
   MEMCPY(k,keys+i*size,size);
   for(j=i+1;j<n;++j) {
     p=keys+j*size;
     if (compare(p,k) < 0) {
       m=j;
       MEMCPY(k,p,size);
     }
   }
   MEMCPY(keys+m*size,keys+i*size,size);
   MEMCPY(keys+i*size,k,size);
 }
 free((void*)k);
}

