/**** 2019 (c)  All rights reserved: see agcopy19.txt ****/

#include "agssrt.h"
#ifndef MEMCPY
#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#endif
#include "math.h"
#define ALN2I   1.442695022
#define TINY    1.0e-5

/* Shell Sort? Written ages ago...I don't know if it works...*/

void q3shell1(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register int i,j,k,s,t,m;
 register char	*x,*keys;
 int 	h[64];

 keys = (char *) akeys;
 x    = (char *) malloc(size*sizeof(char));
 t    = ((int) ( floor(log((double)n)/log(2.0))))-1;
 h[t] = 1;

 for(i=t-1;i>=0;i--) {
   h[i] = 2 * h[i+1] + 1;
 }


 for(m=0;m<=t;++m) {
   k=h[m]; 
   for(i=k;i<n;++i) {
      MEMCPY(x,keys+i*size,size);
      j=i-k;
      s=1;
      while ((j>=0) && (s==1)) {
        if (compare(x,keys+j*size) < 0) {
          MEMCPY(keys+(j+k)*size,keys+j*size,size);
          j=j-k;
        }
        else
          s=0;
      }
      MEMCPY(keys+(j+k)*size,x,size);
    }
  }
}


/* May be based on a N. Wirth PASCAL code or Numerical Recipes code */
/* Check if it works ok ; it might not (vague recollection ) */

void q3shell2(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register int nn,m,i,j,t;
 register char *x, *keys;

 keys = (char *) akeys;
 x    = (char *) malloc(size*sizeof(char));
 t    = (log((double)n)*ALN2I+TINY);
 m=n;

 for(nn=1;nn<=t;++nn){
    m >>=1;
    for(j=m;j<n;++j){
      i=j-m;
      MEMCPY(x,keys+j*size,size);
      while (i>=0 && compare(keys+i*size,x)>0) {
         MEMCPY(&keys[(i+m)*size],&keys[i*size],size);
         i-=m;
      }
      MEMCPY(keys+(i+m)*size,x,size);
    }
  }
}

