/****(c) 2020. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "agsmrgd.h"

void    d8mf1(data *x1, data *x2, int n1, int n2) /*ex mergei */
{
 register int i,j,l;
 register data *temp;
 register data a,b;



 if ((n1<=0)&&(n2<=0)) return;
  temp = (data *) malloc((n1+n2)*sizeof(data));

  i=j=l=0;
  for(;((i<n1) && (j<n2));++l) {
    a=x1[i]; b=x2[j];
    if (a>b) {
     temp[l] =b; 
     ++j;
    }
    else {
     temp[l] =a; 
     ++i;
    }
  }
  if (i <n1) memcpy(&temp[l],&x1[i], (n1-i)*sizeof(data)) ;
  if (j <n2) memcpy(&temp[l],&x2[j], (n2-j)*sizeof(data)) ;
  memcpy(x1, temp, n1 * sizeof(data)) ;
  memcpy(x2, &temp[n1], n2 * sizeof(data)) ;
  free((void *)temp);
}


void d8mf2(data *x1, data *x2, int n1, int n2)

{
 register int  i,j,l;
 register data *temp;
 register data a,b;
 register data *s1=(data*) x1 ,*s2=(data *) x2;
 register int  M;
 register data *SRC, *DES;

 if ((n1<=0)&&(n2<=0)) return;
 temp = (data *) malloc((n1+n2)*sizeof(data));
 i=j=l=0;
  for(;((i<n1) && (j<n2));++l){
    a=*(s1+i) ; b = *(s2+j);
    if ( a >  b){
      *(temp+l)= b; ++j;
    }
    else {
      *(temp+l)= a; ++i;
    }
  }
  if (i < n1) IMEMCPY( temp+l     , s1+i     ,(n1-i)             );
  if (j < n2) IMEMCPY( temp+l     , s2+j     ,(n2-j)             );
  IMEMCPY(s1,temp,n1     );
  IMEMCPY(s2,temp+n1     ,n2     );
  free((void *)temp);
}

void d8mf3(data *x1, data *x2, int n1, int n2)
{
 register int  i,j,l;
 register data *temp;
 register data a,b;
 register data *s1=(data*) x1 ,*s2=(data *) x2;
 register int  M;
 register data *SRC, *DES;

 if ((n1<=0)&&(n2<=0)) return;
 temp = (data *) malloc((n1+n2)*sizeof(data));
 i=j=l=0;
  for(;((i<n1) && (j<n2));++l){
    a=*(s1+i) ; b=*(s2+j);
    if ( b < a ){
      *(temp+l) = b; ++j;
    }
    else {
      *(temp+l) = a; ++i;
    }
  }
  if (i < n1) IMEMCPY( temp+l     , s1+i     ,(n1-i)     );
  if (j < n2) IMEMCPY( temp+l     , s2+j     ,(n2-j)     );
  IMEMCPY(s1,temp,n1     );
  IMEMCPY(s2,temp+n1     ,n2     );
  free((void *)temp);
}

void d8mf4(data *x1, data *x2, int n1, int n2)

{
 register data *temp,*tmp,*first1,*last1,*first2,*last2;
 register data *s1=(data*)x1,*s2=(data*)x2;
 register int  M;
 register data *SRC, *DES;

 if ((n1<= 0)  && (n2<= 0)) return ;
 tmp = (data *) malloc((n1+n2)*sizeof(data));
 first1=s1    ;  first2=s2;
 last1 =s1+n1 ;  last2 =s2+n2;
 temp=tmp;

 for (;((first1 != last1) && (first2 != last2));++temp    )
    if ( *first2 < *first1){
      *temp = *first2; 
      ++first2;
    }
    else {
      *temp = *first1;
      ++first1;
    }
 if ( first1 != last1)
   IMEMCPY(temp,first1,(last1-first1));
 if ( first2 != last2)
   IMEMCPY(temp,first2,(last2-first2));

  IMEMCPY(s1,tmp,n1     ) ;
  IMEMCPY(s2,tmp+n1     ,n2     );
  free((void *)tmp);
}

void d8mf4o(data *x1, data *x2, int n1, int n2)
{
 register int  M;
 register data *temp,*tmp,*first1,*last1,*first2,*last2;
 register data *s1=(data*)x1,*s2=(data*)x2;

 if ((n1<= 0)  && (n2<= 0)) return ;
 tmp = (data *) malloc((n1+n2)*sizeof(data));
 first1=s1    ;  first2=s2;
 last1 =s1+n1 ;  last2 =s2+n2;
 temp=tmp;

 for (;((first1 != last1) && (first2 != last2));++temp    )
    if ( *first2 < *first1){
      *temp = *first2; 
      ++first2;
    }
    else {
      *temp = *first1;
      ++first1;
    }

   if ( first1 != last1)
        for(s1=temp,s2=first1,M=last1-first1;0<M;++s1,++s2,--M)
          *s1=*s2;
   if ( first2 != last2)
        for(s1=temp,s2=first2,M=last2-first2;0<M;++s1,++s2,--M)
          *s1=*s2;
  for(s1= x1,s2=tmp,   M=n1;0<M;++s1,++s2,--M) *s1=*s2;
  for(s1= x2,s2=tmp+n1,M=n2;0<M;++s1,++s2,--M) *s1=*s2;

  free((void *)tmp);
}
