/****(c) 2021. A. Gerbessiotis. See ../KAagcopy.txt ****/
/*******************************************************/
#include "aggssrt.h"



void g2bub1(void *akeys, int n, int size,int(*compare)(const void*,const void*))
{
 register int M;
 register char *SRC, *DES;
 register char  *keys=(char*)akeys, *k;
 register int i,j;
          /* Crazy version of bubble sort ? */
 if (n <= 1) return;
 k   = (char *) malloc(size*sizeof(char));
 for(i=1;i<n;++i) {
   MEMCPY(k,keys+i*size,size);
   for(j=n-1;j>=i;--j) {
     if (compare( keys+(j-1)*size , keys+j*size ) > 0) {
       MEMCPY(k, keys+(j-1)*size ,size);
       MEMCPY( keys+(j-1)*size , keys+j*size ,size);
       MEMCPY( keys+j*size ,k,size);
     }
   }
 }
 free((void*)k);
}

void g2bub2(void *akeys, int n, int size,int(*compare)(const void*,const void*))
{
  register int M;
  register char *SRC, *DES, CH;
  register char *keys=(char *)akeys;  
  register int i,j;

  if (n <= 1) return;
  n--;
  if (n)
    for(i=0; i<n;i++)
      for(j=0; j<n-i;j++)
        if(compare(keys+(j+1)*size,keys+j*size) < 0)
          SWAP((keys+(j+1)*size),(keys+j*size),size)
}

void g2bub3(void *akeys, int n, int size,int(*compare)(const void*,const void*))
{
  register int M;
  register char *SRC, *DES, CH;
  register char *keys=(char *)akeys;  
  register int i,j,s;

  if (n <= 1) return;
  n--;

  if (n) {
    for(i=0; i<n; i++) {
      s=1   ;
      for(j=0; j<n-i; j++) {
        if(compare(keys+(j+1)*size,keys+j*size) < 0) {
          SWAP((keys+(j+1)*size),(keys+j*size),size)
          s=0;
        }
      }
      if (s) break;
    }
  }
}

void g2oets(void *akeys, int n, int size,int(*compare)(const void*,const void*))
{
  register int M;
  register char *SRC, *DES, CH;
  register char *keys=(char *)akeys;  
  register int i,j,s;

  if (n <= 1) return;

  for(i=0; i<n;i++){
    s=1;
    if ((i&1)==1) {
      for(j=1; j<=n-2; j+=2) {
          if(compare(keys+(j+1)*size,keys+j*size)<0) {
          SWAP((keys+(j+1)*size),(keys+j*size),size)
          s=0;
         }
      }
    }
    else {
      for(j=0; j<=n-2; j+=2) {
          if(compare(keys+(j+1)*size,keys+j*size)<0) {
          SWAP((keys+(j+1)*size),(keys+j*size),size)
          s=0;
         }
      }
    }
    if (s) break;
  }
 }
