/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
#include "ssrt.h"

void avg34mi  (void *akeys,int n,int size,int (*compare)(const void*,const void*) )
{
 register char *keys=(char *) akeys;
 register char *DES,*SRC;
 register int  M;
 register char *temp, *tmp, *s, *t;
 register int  i, j, l, ii,jj, a, b;

 if ((n <= 1) ||(size <= 0)) return;
 temp= (char *)malloc(n*size*sizeof(char));

  for(i=0;i<n;i+=TMERGE) {
      BASES (&keys[i*size],MIN(TMERGE,(n-i)),size,compare);
  }
  s=keys;t=temp;
  for(a=TMERGE; a<n; a=(a<<1)) { 
      for(b=0;  b<n; b+=(a<<1)) {
         ii=MIN(b+(a<<1),n);jj=MIN(b+a,n);
         i=jj;j=b;l=b;  
         while ((i<ii)&&(j<jj)) {
           if (compare(&s[i*size],&s[j*size])<0) {
              MEMCPY(&t[l*size],&s[i*size],size);
              ++i; ++l; 
           }
           else {
              MEMCPY(&t[l*size],&s[j*size],size);
              ++j;++l;
           }
         }

         if (i<ii) MEMCPY(&t[l*size],&s[i*size],(ii-i)*size);    
         if (j<jj) MEMCPY(&t[l*size],&s[j*size],(jj-j)*size);
        }
      tmp=s;s=t;t=tmp;
    }

  if (s!=keys) MEMCPY(keys,s,n*size); 

  free(temp);
}
