/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"

void bg7mnsift(void *akeys,int n,int size,int (*compare)(const void*,const void*),int l,int r)
{
  register int i,j;
  char	*x,*keys;

  keys= (char *)akeys;
  x = (char *) malloc(size*sizeof(char));
  i=l;j=2*i;
  memcpy(x,&keys[(i-1)*size],size);

  while ( j <= r) {
    if (j < r) {
      if (compare(&keys[(j-1)*size],&keys[(j)*size]) > 0) {
	j++;
      }
    }
    if (compare(x,&keys[(j-1)*size]) <= 0)
      break;

    memcpy(&keys[(i-1)*size],&keys[(j-1)*size],size);
    i=j;j=2*i;
  }
  memcpy(&keys[(i-1)*size],x,size);
}
	

void bg30heapn(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
  register int l,r;
  char	*x,*keys;

  keys=(char *)akeys;
  l = n/2+1; r=n;
  x = (char *) malloc(size*sizeof(char));

  while (l > 1) {
    l--;
    bg7mnsift(keys,n,size,compare,l,r);
  }
  while (r > 1) {
    memcpy(x,&keys[0],size);
    memcpy(&keys[0],&keys[(r-1)*size],size);
    memcpy(&keys[(r-1)*size],x,size);
    r--;
    bg7mnsift(keys,n,size,compare,l,r);
  }

  for(l=0;l<n/2;l++) {
    memcpy(x,&keys[l*size],size);
    memcpy(&keys[l*size],&keys[(n-l-1)*size],size);
    memcpy(&keys[(n-l-1)*size],x,size);
  }
}
