/****Copyright (c) 1997-2004 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"
/*This is g55: Optimized? g41qsnt/g48qsnt */

void bg55qsnt(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int i,j,l,r,s;
/*
 char	*x,*y;
*/
 char x[64],y[64];
 char *keys;
 register char  *pi,*pj;
 static int     lstack[STSZ];
 static int	rstack[STSZ];

  keys = (char *) akeys;
/*
  x = (char *) malloc(size*sizeof(char));
  y = (char *) malloc(size*sizeof(char));
*/
  s=0;
  lstack[0]=0;rstack[0]=n-1;
do {
    l=lstack[s]; r=rstack[s]; s--;
    do {
	i=l; 
	j=r; 
	memcpy(x,&keys[((l+r)>>1)*size],size);
        pi=&keys[i*size];
        pj=&keys[j*size];
	do {
          while (compare(pi,x) < 0) {i++;pi+=size;}
          while (compare(x,pj) < 0) {j--;pj-=size;}

	  if (i <= j ) {
            memcpy(y,pi,size);
            memcpy(pi,pj,size);
            memcpy(pj,y,size);
            i++; pi +=size;
            j--; pj -=size;
           }
	} while (i <= j); 
		
	if (i < r) {
          if ((r-i) <THRES16 )
	    BASES (pi,(r-i+1),size,compare);
          else {
	    s++; lstack[s]=i; rstack[s]=r;
          }
        }
	r=j;
      } while ( l < r);

   } while (s>= 0);
/*
 free((void *)x); free((void *)y);
*/
}
