/****Copyright (c) 1997-2014 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "ssrt.h"

/*
void g21ins(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int i,j, M;
 register char *DES,*tmp,*SRC,*p;
 char *keys= (char*) akeys;

 if (n <=1) return;
 tmp = (char *) malloc(size*sizeof(char));
#ifdef SANITY_CHECK
  check_if_null(tmp,"g21ins","tmp");
#endif
 for(j=1;j<n;j++) {
   MEMCPY(tmp,(keys+j*size),size);
   i=j-1; p=keys+i*size;
   while ( (i>=0) && ( compare(p,tmp)>0) ) {
     MEMCPY((p+size),(p),size);
     i--;p-=size;
   }
   MEMCPY((p+size),tmp,size);
 }
 free((void *)tmp);
}
*/

void g21ins(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int  M;
 register char *DES,*SRC,*p, *jp, *tmp;
 register char *keys= (char*) akeys ;
 if (n <=1) return;
 tmp = (char *) malloc(size*sizeof(char));
 for(jp=keys+size; jp<(keys+n*size); jp+=size) {
   MEMCPY(tmp,jp,size);
   p=jp-size;
   while ( (p>=keys) && ( compare(p,tmp)>0) ) {
     MEMCPY((p+size),(p),size);
     p-=size;
   }
   MEMCPY((p+size),tmp,size);
 }
}
/* middle one is being used
void g21ins(void *akeys, int n, int size, int (*compare) (const void*,const void*))
{
 register int  M;
 register char *DES,*SRC,*p, *jp, *tmp;
 register char *keys= (char*) akeys;
 if (n <=1) return;
 tmp = (char *) malloc(size*sizeof(char));
 for(jp=keys+size; jp<(akeys+n*size); jp+=size) {
   MEMCPY(tmp,jp,size);
   for(p=jp;p > keys &&( compare(p-size,tmp)>0); p-=size){
     MEMCPY((p),(p-size),size);
   }
   MEMCPY((p),tmp,size);
 }
 free((void *)tmp);
}
*/

