/****Copyright (c) 1997-2014 All rights reserved
 ****A. V. Gerbessiotis and C. J. Siniolakis
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/
#include "issrt.h"

void i34mi (idata *keys,int n)
{
 idata *DES,*SRC;
 idata *temp;
 register idata *tmp,*s,*t;
 register int i,j,l,phase,q,r,k,M;

  if (n<=1) return;
  temp= (idata *) malloc(n*sizeof(idata));
#ifdef SANITY_CHECK
 avg_checknull(temp,"i31mrgit","temp");
#endif
  for(k=0;k<n;k+=TMERGEI){
    BASEI (&keys[k],MIN(TMERGEI,(n-k)));
  }
  s=keys;t=temp;
  for(phase=TMERGEI;phase<n;phase=Times2(phase)) { 
    for(k=0;k<n;k+=Times2(phase)){
      q=MIN(k+Times2(phase),n);r=MIN(k+phase,n);
      i=r;j=k;l=k;  
      while((i<q)&&(j<r)) {
        if (s[i]<s[j]) {
          t[l]=s[i];
          i++;l++; 
        }
        else {
          t[l]=s[j];
          j++;l++;
        }
      }
/*
      if (i<q) MEMCPY(&t[l],&s[i],((q-i)*sizeof(idata)));    
      if (j<r) MEMCPY(&t[l],&s[j],((r-j)*sizeof(idata)));
*/
      if (i<q) IMEMCPY(&t[l],&s[i],((q-i)));    
      if (j<r) IMEMCPY(&t[l],&s[j],((r-j)));
     }
     tmp=s;s=t;t=tmp;
   }
/*
  if (s!=keys) MEMCPY(keys,s,(n*sizeof(idata))); 
*/
  if (s!=keys) IMEMCPY(keys,s,(n)); 

  free((void*)temp);  
}
