/****Copyright (c) 1997-2005 All rights reserved
 ****A. V. Gerbessiotis 
 ****Permission to use, copy, modify, and distribute this software,
 ****and to incorporate it, in whole or in part, into 
 ****other software,is hereby granted without fee, provided that
 ****  (1) the above copyright notice and this permission 
 ****      notice appear in all copies of the source code, and 
 ****      the above copyright notice appear in clearly visible 
 ****      form on all supporting documentation and distribution 
 ****      media, and
 ****     (2) any redistribution of the software, in original
 ****         or modified form, be without fee and subject to
 ****         these same conditions.
 ****   No guarantee, whatsoever, is offered that the code works as
 ****   advertised or is absent of any, even damaging,
 ****   side-effects. Use this code at your own personal risk.
 ****/

#include "issrt.h"
void i55non0 (idata *keys, int n)
{
  register int i,j,l,r,s;
  register idata	x,y;
  int	lstack[STACK_SIZE_QS];
  int	rstack[STACK_SIZE_QS];
  s=0;
  lstack[0]=0;rstack[0]=n-1;
  do {
    l=lstack[s]; r=rstack[s]; s--;
    do {
      i=l;
      j=r;
      x=keys[(l+r)/2];
      do {
        while (keys[i] < x) i++;
        while (x<keys[j] ) j--;
        if (i <= j ) {
          y=keys[i];
          keys[i]=keys[j];
          keys[j]=y;
          i++;
          j--;
        }
       } while (i <= j); 
       if (i < r) {
         s++; lstack[s]=i; rstack[s]=r;
       }
       r=j;
    } while ( l < r);
  } while (s>= 0);
}
