#include <memory.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>


typedef unsigned int idata;

#ifndef TRUE
#define TRUE            1
#endif
#ifndef FALSE
#define	FALSE		0
#endif
#ifndef MIN
#define	MIN(x,y)	((x)<=(y)?(x):(y)) 
#endif
#ifndef MAX
#define	MAX(x,y)	((x)>=(y)?(x):(y))
#endif
#ifndef CEIL
#define CEIL(X,Y)       ((X != 0)?(1+ (X-1)/Y):0)  
#endif
#ifndef FLOOR
#define FLOOR(X,Y)      (X/Y)  
#endif
#define OLD_CEIL(X,Y)   ((((X/Y)*Y)==X)?(X/Y):(X/Y+1))  
#define LEFT(x,y)       (x-(x/y)*y)
#define         Div2(x)              ((x) >> 1)
#define         Times2(x)            ((x) << 1)
#define         CDiv(x, y)           (((x) != 0)?((((x) - 1)/(y))+1):0)
#define         Mask(x, sbit, nbits) ((x >> sbit) & ~(UINT_MAX << nbits))

void check_if_null(void *, char *, char *); /* in inulchk.c */
#undef SANITY_CHECK

#define STACK_SIZE_QS 64
#define STSZ STACK_SIZE_QS


#define GRANDOM(X)  (int)((random()/((double)2147483647.0))*X)
#define RANDOM()    random()
#define SRANDOM(X)  srandom((unsigned int)X)
#define GSRANDOM()   srandom((unsigned int)time(NULL))
#define THRESI   24
#define TMERGEI  8
#define THRESI8   8
#define THRESI12 12
#define THRESI16 16
#define THRESI24 24
#define THRESI32 32
#define FIRST_KEY  0
#define MIDDLE_KEY 1
#define RANDOM_KEY 2
#define SPLITTER  MIDDLE_KEY


#define BASEI  i21ins

void i32rdx2(unsigned int *, int); /* Two  round radix-65536 32-bit unsigned int sorting */
void i32rdx4(unsigned int *, int); /* Four round radix-256   32-bit unsigned int sorting */
void o32rdx4(unsigned int *, int); /* Four round radix-256   32-bit unsigned int sorting */
void r32rdx4(unsigned int *, int); /* Four round radix-256   32-bit unsigned int sorting */
void i32rdx (unsigned int *, int); /* 32-bit unsigned int sorting, Algorithm decides on rounds */
void i01ins (unsigned int *, int); 
void i21ins (unsigned int *, int); 
void i22ins (unsigned int *, int); 
void i30mi  (unsigned int *, int); 
void i34mi  (unsigned int *, int); 
void i43hx  (unsigned int *, int); 
void i44hx  (unsigned int *, int); 
void i45hx  (unsigned int *, int); 
void i50qw  (unsigned int *, int); 
void i52dbh (unsigned int *, int); 
void i63fbc (unsigned int *, int); 
void i55non0(unsigned int *, int); 
void i55non1(unsigned int *, int); 
void ignu01 (void *, int,int,int (*) (const void *,const void *)); 
void o50qw  (unsigned int *, int); 

int FLog2(int);
int CLog2(int);
int Exp2(int);


#define MEMCPY(X,Y,SIZE)  memcpy((X),(Y),(SIZE))
#define IMEMCPY(X,Y,SIZE) memcpy((X),(Y),(SIZE))
#undef MEMCPY
#undef IMEMCPY
#define MEMCPY(XX,YY,SS)  {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }
#define IMEMCPY(XX,YY,SS) {DES=(XX);SRC=(YY);M=(SS); do {*DES++=*SRC++;} while (--M); }
